﻿package classes {
	
    import flash.display.Sprite;

    import org.papervision3d.core.proto.SceneObject3D;
    import org.papervision3d.objects.DisplayObject3D;


    public class Group extends DisplayObject3D
    {

        public function Group( name:String=null, initObject:Object=null ){
            super(name, null, initObject);
            this.container = new Sprite();
        }


        //Override Methods
        public override function addChild( child :DisplayObject3D, name:String=null ):DisplayObject3D{
            child = super.addChild(child, name);
            child.container = new Sprite();
            for each( var cChild:DisplayObject3D in child.children ){
                cChild.container = new Sprite();
            }
            this.container.addChild(child.container);
            return child;
        }

        public override function render(scene:SceneObject3D):void{

            for( var j:int = 0; j<this.container.numChildren; j++ )
                Sprite(this.container.getChildAt(j)).graphics.clear();

            var iFaces :Array = super._sorted;

            iFaces.sortOn( 'screenZ', Array.DESCENDING | Array.NUMERIC );

            // Render
            var container :Sprite = this.container || scene.container;
            var rendered  :Number = 0;
            var iFace     :Object;

            for( var i:int = 0; iFace = iFaces[i]; i++ )
            {
                if( iFace.visible ){
                    container.addChild( iFace.instance.container );
                    rendered += iFace.face.render( iFace.instance, iFace.instance.container );
                }
            }

            // Update stats
            scene.stats.rendered += rendered;
        }
    }
}