﻿package classes {
	import flash.display.Sprite;
	import caurina.transitions.Tweener;
	
	import org.papervision3d.utils.InteractiveSprite;
	import flash.events.Event;
	import classes.Group;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	import org.papervision3d.scenes.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.events.*;
	
	import flash.display.StageAlign;
	
	public class Object3D extends Sprite{
		
		private var container:Sprite;
		private var scene:InteractiveScene3D;
		private var camera:Camera3D;
		private var rootNode:Group;
		private var planes:Array = [];
		private var planePos:Array = [];
		
		private var numplanes:Number = 8;
		private var timer:Timer;
		
		private var rotX       : Number = 0;   
        private var rotY       : Number = 0;   
		private var vPos:Number = 1;
		public function Object3D() {
			
			stage.quality   = "MEDIUM";   
            stage.scaleMode = "noScale";   
            stage.align = StageAlign.TOP_LEFT;
			
			init3D();
			initTimer();
			addEventListener(Event.ENTER_FRAME, loop);
			
		}
		
		private function init3D() {
			// コンテナ生成 
			this.container = new InteractiveSprite();
			addChild(this.container);
			this.container.x = this.stage.stageWidth  / 2;
            this.container.y = this.stage.stageHeight / 2;
			
			// シーン生成   
            scene = new InteractiveScene3D( container );
			
			// カメラ設定
			camera = new Camera3D()
			camera.zoom = 11;
			camera.x =  0;
			camera.y = 0;
			camera.focus = 100;
			
			//オブジェクト配置
			rootNode = new Group( "rootNode" );
			scene.addChild(rootNode);
			
			for (var i:int = 0; i < numplanes; i++) {
				var material:InteractiveMovieAssetMaterial = new InteractiveMovieAssetMaterial("MaterialMc",true,true);
				material.doubleSided = true;
				material.movie.alpha = 0.8;
				var initObj:Object = createPosition(i ,false);
				var plane:Plane = new Plane(material , material.movie.width , material.movie.height, 8, 8 , initObj);
				planes.push(plane);
				rootNode.addChild(plane);
			}
			
			createPosition(-1 , true);
			
		}	
		
		private function loop(event:Event):void {
			//  マウス座標でオブジェクト全体を回転   
			camera.x = -(container.mouseX * 3)/2;
			camera.y = (container.mouseY * 3);

			scene.renderCamera(camera);
			
		}
		
		private function createPosition(num:Number , first:Boolean ):Object {
			var obj:Object = new Object();
			
			var rad:Number = (360 / (numplanes + 4)) * num * Math.PI / 180;
			vPos *= 1.1;
			
			obj.x = Math.sin(rad) * 400;
			obj.y = num * 200;
			obj.z = num * 400 * vPos;
			
			if (first) {
				planePos.unshift(obj);
			} else {
				planePos.push(obj);
			}
			
			return obj;
		}
		
		private function initTimer() {
			timer = new Timer(1000, 0);
			timer.addEventListener(TimerEvent.TIMER, onTimer);
			timer.start();
		}
		
		private function onTimer(e:TimerEvent) {
			var speed:Number = 0.8;
			
			for (var i:int = 0; i < numplanes; i++) {
				var pos:Object = planePos[i];
				var plane:Plane = planes[i];
				
				Tweener.addTween(plane, { 
										x : pos.x,
										y : pos.y,
										z : pos.z,
										transition    :"easeoutquad",
										time        :speed
										} );
			}
			
			//新しいPlaneを作成
			var material:InteractiveMovieAssetMaterial = new InteractiveMovieAssetMaterial("MaterialMc",true,true);
			material.doubleSided = true;
			material.movie.alpha = 0.8;
			var plane:Plane = new Plane(material , material.movie.width , material.movie.height, 8, 8 , planePos[numplanes]);
			planes.push(plane);
			rootNode.addChild(plane);
			plane.scale = 0;
			Tweener.addTween(plane, { 
									scale : 1,
									transition    :"easeoutquad",
									time        :speed
									} );
			
			//古いPlaneを削除
			var NextTimer:Timer = new Timer(speed * 1000 + 100, 1);
			NextTimer.addEventListener(TimerEvent.TIMER, function () {
				var del:Plane = planes.shift();
				rootNode.removeChild(del);
			})
			NextTimer.start();
			
			
			

		}
	}
	
}